<template>
  <div>
    <div class="btn-action-container">
      <img
        :src="asset('images/ui_elements/ic_edit.png')"
        alt="icon info"
        class="btn-action"
        @click="showModal()"
      >
    </div>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
    >
      <div class="container" v-if="content">
        <div class="row mb-2">
          <div class="col-md-6">
            <h5>Edit Product</h5>
          </div>
          <div class="col-md-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-md-12">
            <form class="form-material" @submit.prevent="submitForm">
              <div class="form-group">
                <label>Name</label>
                <input
                  type="title"
                  class="form-control"
                  name="name"
                  v-validate="'required'"
                  v-model="content.name"
                >
                <small class="text-danger">{{ errors.first('name') }}</small>
              </div>
              <div class="form-group">
                <label>Description</label>
                <textarea
                  v-model="content.description"
                  name="description"
                  v-validate="'required'"
                  class="form-control"
                ></textarea>
                <small class="text-danger">{{ errors.first('description') }}</small>
              </div>

              <div class="form-group">
                <label>Price</label>
                <input
                  :value="formatCurrency(content.price)"
                  name="price"
                  v-validate="'required'"
                  class="form-control"
                  readonly
                >
                <small class="text-danger">{{ errors.first('price') }}</small>
              </div>

              <div class="form-group">
                <label>Fee</label>
                <input
                  v-model="content.fee"
                  name="fee"
                  v-validate="'required'"
                  class="form-control"
                  type="number"
                >
                <small class="text-danger">{{ errors.first('fee') }}</small>
              </div>

              <div class="form-group">
                <label>Status</label>
                <select name="gender" class="form-control" v-model="content.is_active">
                  <option value="true">Active</option>
                  <option value="false">Not Active</option>
                </select>
              </div>
              <div class="form-group row">
                <div class="col-md-12">
                  <label>Detail</label>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Category</small>
                  <input
                    type="text"
                    class="form-control"
                    v-model="content.category.category"
                    readonly
                  >
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Type</small>
                  <input type="text" class="form-control" v-model="content.type.type" readonly>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Operator</small>
                  <input
                    type="text"
                    class="form-control"
                    v-model="content.operator.operator"
                    readonly
                  >
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-12">
                  <label>Kudo Detail</label>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Kudo Code</small>
                  <input type="text" class="form-control" v-model="content.kudo_code" readonly>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Kudo B2B Price</small>
                  <input
                    type="text"
                    class="form-control"
                    :value="formatCurrency(content.kudo_b2b_price)"
                    readonly
                  >
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Status</small>
                  <input type="text" class="form-control" v-model="content.kudo_is_active" readonly>
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-12">
                  <label>Portal Pulsa Detail</label>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Portal Pulsa Code</small>
                  <input
                    type="text"
                    class="form-control"
                    v-model="content.portal_pulsa_code"
                    readonly
                  >
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Kudo B2B Price</small>
                  <input
                    type="text"
                    class="form-control"
                    :value="formatCurrency(content.portal_pulsa_b2b_price)"
                    readonly
                  >
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Status</small>
                  <input
                    type="text"
                    class="form-control"
                    v-model="content.portal_pulsa_is_active"
                    readonly
                  >
                </div>
              </div>
              <button type="submit" class="btn btn-primary form-control capsule">
                <span v-if="loading">
                  Updating
                  <i class="fas fa-circle-notch fa-spin"></i>
                </span>
                <span v-else>Save</span>
              </button>
            </form>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";
import FormatMixin from "@/mixins/FormatMixin";

export default {
  mixins: [FormatMixin],

  data() {
    return {
      loading: false,
      files: null
    };
  },
  props: ["content"],
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show();
    },

    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          this.loading = true;
          let response = await this.$axios.put(
            process.env.MIX_APP_URL +
              `/api/${this.$store.getters.appId.hashed}/ppob-product/${
                this.content.id
              }`,
            { ...this.content, image_url: this.content.image }
          );

          this.hideModal();
          EventBus.$emit("refreshTable");
          httpHelper.successToast(this, response.data.message);
        } catch (error) {
          httpHelper.errorToast(this, error);
        }
      } else {
        // this.$refs.lennaModal.show('alert','Sorry','You must correct your form first')
      }
      this.loading = false;
    }
  }
};
</script>
<style lang="scss" scoped>
.nav-link.active {
  background: #dadada !important;
  color: #1d68a7;
}
.tab-content {
  word-wrap: break-word;
}
.image-container {
  background: #e8e8e8;
  max-height: 400px;
  & input {
    opacity: 0 !important;
    height: 100%;
    position: absolute;
    top: 0;
  }
  & img {
    max-height: 250px;
  }
}
</style>
